DAT programName         byte "fourMotorsOneCog130205a", 0
CON
{{
  Based on code by Hanno.

  Controls four motor with one cog.

  Known Issues:

  Awkward use of "SPEED_MULTIPLIER" constant.
  I'm pretty sure I the value of MIN_PASM_WAIT
  may be reduced.
  I don't like the way "MIN_PASM_WAIT" gets
  added to all values to make sure they aren't
  too small. I'd like to see a check perform and
  only add to wait values when needed to prevent
  values that are too low.
  
  
}}
{
  121215a Begin converting Hano's two motor driver into a four
  motor driver.
  15a Mostly just change formatting.
  15b Remove encoder code.
  15e Change masks to arrays.
  15l Seems to work.
  15m Remove debug code.
  130125a Comment out debug code (again).
  05a Add additional comments

  Todo:
  Check for identical power settings and turn identical
  settings on and off at the same time.

  
}
{*******************************************************
* (C) 2010 HannoWare.com                               *
* Drive 2 motors with h-bridge and read encoder        *
* AppletImage=motor.gif                                *
********************************************************}
CON
 
  MAXSPEED = 4000
  PARENT_MAXSPEED = 1000
  SPEED_MULTIPLIER = MAXSPEED / PARENT_MAXSPEED
  MIN_PASM_WAIT = 40 '5
  
CON 'Constants used in "Set" method.

  'MAX_PULSE = 2000  
  'MIN_PULSE = 1000
  STOP_PULSE = 1500
  
VAR

  long cog
  long motorControlArray[10]  'structure populated by spin code to set motor direction
  long forwardMask[4]
  long backwardMask[4]
  long enableMask[4]
  long speed[4]

PUB Start(forwardPin0, forwardPin1, forwardPin2, forwardPin3, {
             } backwardPin0, backwardPin1, backwardPin2, backwardPin3, {
             } enablePin0, enablePin1, enablePin2, enablePin3)
'' Starts 1 motor cog.  

  if forwardPin0 <> -1 and backwardPin0 <> -1 and enablePin0 <> -1
    forwardMask[0] := |< forwardPin0
    backwardMask[0] := |< backwardPin0
    enableMask[0] := |< enablePin0
  else
    forwardMask[0] := 0
    backwardMask[0] := 0
    enableMask[0] := 0
  if forwardPin1 <> -1 and backwardPin1 <> -1 and enablePin1 <> -1
    forwardMask[1] := |< forwardPin1
    backwardMask[1] := |< backwardPin1
    enableMask[1] := |< enablePin1
  else
    forwardMask[1] := 0
    backwardMask[1] := 0
    enableMask[1] := 0
  if forwardPin2 <> -1 and backwardPin2 <> -1 and enablePin2 <> -1
    forwardMask[2] := |< forwardPin2
    backwardMask[2] := |< backwardPin2
    enableMask[2] := |< enablePin2
  else
    forwardMask[2] := 0
    backwardMask[2] := 0
    enableMask[2] := 0
  if forwardPin3 <> -1 and backwardPin3 <> -1 and enablePin3 <> -1
    forwardMask[3] := |< forwardPin3
    backwardMask[3] := |< backwardPin3
    enableMask[3] := |< enablePin3
  else
    forwardMask[3] := 0
    backwardMask[3] := 0
    enableMask[3] := 0
  Stop

  motorControlArray[1] := MIN_PASM_WAIT
  motorControlArray[3] := MIN_PASM_WAIT
  motorControlArray[5] := MIN_PASM_WAIT
  motorControlArray[7] := MIN_PASM_WAIT
  motorControlArray[9] := MIN_PASM_WAIT
  diraV := forwardMask[0] | forwardMask[1] | forwardMask[2] | forwardMask[3] | {
  } backwardMask[0] | backwardMask[1] | backwardMask[2] | backwardMask[3] | {
  } enableMask[0] | enableMask[1] | enableMask[2] | enableMask[3]
  andV := !diraV
  cognew(@doPWM, @motorControlArray)

PUB Stop
'' Stop driver and release cog

  if cog
    cogstop(cog~ - 1)
 
PUB Update(speed0, speed1, speed2, speed3)| activeMask, speedIndex[4], startIndex, arrayIndex
'' Updates motor control with desired speeds.
'' Speeds should be between -1000 and 1000.
 
  ' combined PWM pin mask
  activeMask := 0
  if speed0 > 0
    activeMask += forwardMask[0]                        ' if #0 positive speed add positive
                                                        ' direction pin to mask
  else
    activeMask += backwardMask[0]                       ' if #0 negative speed add negative
                                                        ' direction pin to mask
  if speed1 > 0
    activeMask += forwardMask[1]                        
  else
    activeMask += backwardMask[1]
  if speed2 > 0
    activeMask += forwardMask[2]                        
  else
    activeMask += backwardMask[2]
  if speed3 > 0
    activeMask += forwardMask[3]                        
  else
    activeMask += backwardMask[3]
                           
  speed[0] := (||speed0 * SPEED_MULTIPLIER) <# MAXSPEED
  speed[1] := (||speed1 * SPEED_MULTIPLIER) <# MAXSPEED
  speed[2] := (||speed2 * SPEED_MULTIPLIER) <# MAXSPEED
  speed[3] := (||speed3 * SPEED_MULTIPLIER) <# MAXSPEED
  repeat result from 0 to 3
    if speed[result]
      activeMask |= enableMask[result]

  '' Sort speeds lowest to highest.
  ' There must be a beter way to do this (sorting).
  
  speedIndex[0] := 0
  repeat result from 1 to 3
    if speed[result] > speed[speedIndex[0]]
      speedIndex[0] := result
  
  repeat result from 1 to 3
    if result <> speedIndex[0]
      startIndex := result
      quit 
  speedIndex[1] := startIndex
  repeat result from startIndex to 3
    if result <> speedIndex[0]
      if speed[result] > speed[speedIndex[1]]
        speedIndex[1] := result
       
  repeat result from 0 to 3
    if result <> speedIndex[0] and result <> speedIndex[1]
      startIndex := result
      quit 
  speedIndex[2] := startIndex
  repeat result from startIndex to 3
    if result <> speedIndex[0] and result <> speedIndex[1]
      if speed[result] > speed[speedIndex[2]]
        speedIndex[2] := result
 
  repeat result from 0 to 3
    if result <> speedIndex[0] and result <> speedIndex[1] and result <> speedIndex[2]
      startIndex := result
      quit 
  speedIndex[3] := startIndex


  motorControlArray[0] := activeMask ' set mask to where the PASM portion
                                     ' can read it
  motorControlArray[1] := speed[speedIndex[3]] + MIN_PASM_WAIT ' time slowest motor is on
 
  arrayIndex := 2
  repeat result from 3 to 1
    activeMask &= !enableMask[speedIndex[result]]
    motorControlArray[arrayIndex++] := activeMask
    motorControlArray[arrayIndex++] := (speed[speedIndex[result - 1]] - speed[speedIndex[result]]) + MIN_PASM_WAIT ' time slowest motor is on

  activeMask &= !enableMask[speedIndex[0]]
  motorControlArray[8] := activeMask
  motorControlArray[9] := (MAXSPEED - speed[speedIndex[0]]) + MIN_PASM_WAIT ' time all motors off

PUB UpdateSingle(motorIndex, localSpeed)

  speed[motorIndex] := localSpeed * SPEED_MULTIPLIER
  Update(speed[0] / SPEED_MULTIPLIER, speed[1] / SPEED_MULTIPLIER, speed[2] / SPEED_MULTIPLIER, speed[3] / SPEED_MULTIPLIER)

PUB Set(pin, width) : motorIndex 
'' Method to provide similar type of input as a continuous rotation servo.
'' "pin" should be the same pin as used to control the enable
'' pin of the H-bridge.
''
'' This method returns the motor ID assigned to "pin" or -1 if "pin" is not
'' not assigned to any motor.
'' This method is not needed for proper operation of object
'' and may be deleted.

  pin := |< pin
  repeat motorIndex from 0 to 3
    if pin & enableMask[motorIndex]
      'width := ((width - STOP_PULSE) * PARENT_MAXSPEED) / (MAX_PULSE - STOP_PULSE)
      width := (width - STOP_PULSE) * 2
      UpdateSingle(motorIndex, width)
      return motorIndex
  motorIndex := -1
   
PUB GetFileName
'' This method returns the name of this object.
'' This method is not needed for proper operation of object
'' and may be deleted.

  result := @programName

PUB GetSpeedLocation
'' This method returns the location of "speed" to aid
'' in debugging the program.
''
'' The value stored in "speed" will be different than the
'' value set by the parent object by the factor "SPEED_MULTIPLIER".
''
'' This method is not needed for proper operation of object
'' and may be deleted.

  result := @speed

PUB GetArrayLocation
'' This method returns the location of "motorControlArray" to aid
'' in debugging the program.
'' This method is not needed for proper operation of object
'' and may be deleted.

  result := @motorControlArray
    
DAT

' outputs pwm to motors
' uses pwm structure to get bit values and duty cycles
                        org
doPWM                   or      dira,dirav
 loop                   mov     ptr,par
                        mov     :i,#5
:duty                   rdlong  orV,ptr 'get value to or
                        add     ptr,#4
                        mov     :t,outa
                        rdlong  timeV, ptr 'get wait
                        add     ptr, #4
                        and     :t, andV
                        or      :t, orV
                        mov     outa, :t
                        add     timeV, cnt
                        waitcnt timeV, #0
                        djnz    :i, #:duty
                        jmp     #loop
:t                      long 1
:i                      long 1
diraV                   long 1
andV                    long 1    
ptr                     long 1
orV                     long 1
timeV                   long 1